module C80Callback
  class MessagesController < ActionController::Base

    protect_from_forgery with: :exception

    # на этот скрипт уходят все сообщения с форм обратной связи, затем отправляется почта владельцу сайта
    def callback_message

      m = Cmessage.new(cmessage_params)

      respond_to do |format|

        if m.save

          format.js
          CallbacksMailer.send_email(m, 'Пользователь сайта просит перезвонить').deliver
        else
          Rails.logger.debug "[TRACE] <MessagesController.callback_message> errors: #{m.errors}"
          format.js { render json: m.errors, status: :unprocessable_entity }
        end

      end

    end

    # на этот скрипт уходят все сообщения с простых форм заказа обратного звонка
    def callback_message_simple

      m = Cmessage.new(cmessage_params)

      respond_to do |format|

        if m.save
          format.js
          CallbacksMailer.send_email(m, 'Пользователь сайта просит перезвонить').deliver
        else
          Rails.logger.debug "[TRACE] <MessagesController.callback_message_simple> errors: #{m.errors.as_json}"
          format.js { render json: m.errors, status: :unprocessable_entity }
        end

      end

    end

    def cmessage_params
      params.require(:cmessage).permit(:name, :mobile, :kapcha)
    end

  end
end